-- 神翼幻化
Lua_GodWingTransPanel = class("Lua_GodWingTransPanel", Lua_DisplayObject);
function Lua_GodWingTransPanel:ctor(p)
	self:superCall("ctor", p, "TransPanel_skin");
end

function Lua_GodWingTransPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.funBtn1RedDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", -127, -249, 0, 0);
	self.funBtn1RedDot:setDepth(10);
	self.funBtn1RedDot:setEnable(false);

	self.monsEffect = UICreate.createUIEffect(self.content, nil, nil, -90, -20);
	self.monsEffect:SetRenderQueue(self.showInfoBg, 1, 2);
	self.monsEffect:setRotEnable(true, -88, -55, 500, 300, 1);
	self.monsEffect:setSacle(140, 140, 140);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 356, 540));
	self.dragList:setLocation(370, -24, 0);
	self.dragList:setListCell(Lua_GodWingTransItem, 113, 356, 1);

	self.attrDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 510, 70));
	self.attrDragList:setListCell(Lua_GodWingAttrItem, 30, 240, 2);
	self.attrDragList:setLocation(-88, -155, 0);
	self.attrDragList.canDrag = false;

	self.funBtn1.label = ""; -- LanUtil.getValue(110512);
	self.funBtn2.label = ""; -- LanUtil.getValue(110260);
	self.funBtn1:addClickFuntion(self, self.onFunBtn1);
	self.funBtn2:addClickFuntion(self, self.onFunBtn2);
	self.resPlusBtn:addClickFuntion(self, self.onResPlusBtn);

	self:addLuaEvent("GODWING_TRANS_PANEL_UPDATE", self, self.updatePanel);
	self:addLuaEvent("TRANS_PANEL_BTN", self, self.onSkinChildCellClick);
	DataCenter.godWingTransData:sGetPanelInfo();
end

-- 默认显示选中 vo为道具vo
function Lua_GodWingTransPanel:showDefaultData(tvo)
	self.defaultData = tvo;
end

function Lua_GodWingTransPanel:updatePanel()
	local arr = DataCenter.godWingTransUtil.godWingIllusionArr;
	local toIndex = 1;
	for i = 1, arr:getSize() do
		arr[i].select = false;
		if self.wingShapeInfo == nil then
			arr[1].select = true
		else
			arr[i].select = arr[i].id == self.wingShapeInfo.id;
			if arr[i].id == self.wingShapeInfo.id then
				toIndex = i;
			end
		end
	end

	-- 默认显示
	if self.defaultData ~= nil then
		for i = 1, arr:getSize() do
			arr[i].select = arr[i].illusion_id == self.defaultData.id;
			if arr[i].illusion_id == self.defaultData.id then
				toIndex = i;
			end
		end
		self.defaultData = nil;
	end
	self.dragList:setLuaArrayData(arr, false);
	self.dragList:moveToIndex(toIndex, true);

	self:updateData(arr[toIndex]);
end

function Lua_GodWingTransPanel:onSkinChildCellClick(itemInfo)
	local toIndex;
	local arr = DataCenter.godWingTransUtil.godWingIllusionArr;
	for i = 1, arr:getSize() do
		arr[i].select = arr[i].id == itemInfo.id;
		if arr[i].id == itemInfo.id then
			toIndex = i;
		end
	end
	self.dragList:setLuaArrayData(arr, false);

	self:updateData(itemInfo);
end

function Lua_GodWingTransPanel:updateData(itemInfo)
	self.wingShapeInfo = itemInfo;

	self.monsEffect:setUrl(itemInfo.floder .. "/" .. itemInfo.fileName, tostring(itemInfo.modelName));
	self.monsEffect:setRot(itemInfo.modelRosDic[1], itemInfo.modelRosDic[2], itemInfo.modelRosDic[3]);
	self.monsEffect:setSacle(itemInfo.modelScaDic[1], itemInfo.modelScaDic[2], itemInfo.modelScaDic[3]);  
	self.monsEffect:setLocation(itemInfo.modelPosDic[1], itemInfo.modelPosDic[2], itemInfo.modelPosDic[3]);
	
	if itemInfo.isIllusion then
		self.funBtn2.label = LanUtil.getValue(110262);
	else
		self.funBtn2.label = LanUtil.getValue(110260);
	end

	if itemInfo.is_unlock == 0 then 
		self.funBtn1.label = LanUtil.getValue(110512);
	else
		self.funBtn1.label = LanUtil.getValue(110511);
	end
	self:setBtnInfo(self.funBtn1, itemInfo.is_unlock ~= 0 or itemInfo.packItemNum >= itemInfo.debrisItemNum);
	self:setBtnInfo(self.funBtn2, itemInfo.is_unlock ~= 0);

	if itemInfo.packItemNum >= itemInfo.debrisItemNum  then
		self.needNumTxt.text = itemInfo.packItemNum .. "/" .. itemInfo.debrisItemNum
	else
		self.needNumTxt.text = "[FF1616]"..itemInfo.packItemNum.."[-]" .. "/"..itemInfo.debrisItemNum
	end
	self.funBtn1RedDot:setEnable(itemInfo.packItemNum >= itemInfo.debrisItemNum and itemInfo.level ~= 50);

	self.attrDragList:setLuaArrayData(itemInfo.getPropertyData, false);
	if itemInfo.getPropertyData:getSize() > 4 then
		self.attrDragList:setRect(Vector4(0, 0, 510, 100));
		self.attrDragList:setSubPos(-120, 10, 0); -- 30 -> (y + 90 /2 - 30 / 2)
	else
		self.attrDragList:setRect(Vector4(0, 0, 510, 70));
		self.attrDragList:setSubPos(-120, 0, 0); -- -255 -> (x - 510 /2 + 240 / 2)
	end

	local tvo = Lua_ToolVo.new(itemInfo.illusion_id);
	self.outputTxt.text = tvo.interfaceOutput;
end

function Lua_GodWingTransPanel:setBtnInfo(btn, isEnable)
	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	if btn == self.funBtn1 then
		self.isfunBtn1Enable = isEnable;
		btn:setMouseEnable(isEnable);
		btn:setStyle(isEnable and 13 or 12);
		btn.txt.colorStr = isEnable and normalStr or grayStr;
	elseif btn == self.funBtn2 then
		self.isfunBtn2Enable = isEnable;
		btn:setMouseEnable(isEnable);
		btn:setStyle(isEnable and 15 or 14);
		btn.txt.colorStr = isEnable and normalStr or grayStr;
	end
end

function Lua_GodWingTransPanel:onFunBtn1()
	if self.wingShapeInfo.level == 0 then
		local cmd = getProtoMsg("Proto11404204");
		cmd.ill_id = self.wingShapeInfo.id ;
		sendMsg(11404204, cmd);
	else
		local cmd = getProtoMsg("Proto11404205");
		cmd.ill_id = self.wingShapeInfo.id;
		sendMsg(11404205, cmd);
	end
end

function Lua_GodWingTransPanel:onFunBtn2()
	local cmd = getProtoMsg("Proto11404206");
	cmd.ill_on = self.wingShapeInfo.isIllusion and 0 or 1; 
	cmd.ill_id = self.wingShapeInfo.id;
	sendMsg(11404206, cmd);
end

function Lua_GodWingTransPanel:onResPlusBtn()
	local arr = Array();
	arr:add(Lua_ToolVo.new(self.wingShapeInfo.debrisItemId, 1, 1));
	Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
end

function Lua_GodWingTransPanel:dispose()
	if self.funBtn1RedDot ~= nil then
		self.funBtn1RedDot:dispose();
		self.funBtn1RedDot = nil;
	end
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.attrDragList ~= nil then
		self.attrDragList:dispose();
		self.attrDragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_GodWingAttrItem = class("Lua_GodWingAttrItem", Lua_ListCell);
function Lua_GodWingAttrItem:ctor(p)
	self:superCall("ctor", p, "petAttItem_skin");
end

function Lua_GodWingAttrItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.label.text = data.name .. "：";

	if data.show_percent == 0 then
		self.txt.text = data.val;
		self.increaseTxt.text = data.nextVal;
	else
		self.txt.text = data.val.."%";
		self.increaseTxt.text = data.nextVal .. "%";
	end

	local posX = self.label.mainContent.transform.localPosition.x;
	local posY = self.label.mainContent.transform.localPosition.y;
	self.txt:setLocation(posX + self.label.width, posY);

	posX = self.txt.mainContent.transform.localPosition.x;
	posY = self.txt.mainContent.transform.localPosition.y;
	-- self.increaseObj.transform.localPosition = Vector3(posX + self.txt.width, posY, 0);
	LuaUtil.setObjPos(self.increaseObj, posX + self.txt.width, posY, 0);
	self.increaseObj:SetActive(data.level >= 1 and data.nextVal ~= 0);
end





--------------------------------------------------





Lua_GodWingTransItem = class("Lua_GodWingTransItem", Lua_ListCell);
function Lua_GodWingTransItem:ctor(p)
    self:superCall("ctor", p, "ServantTransItem_skin");
end

function Lua_GodWingTransItem:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImage = Lua_ToolImage.new(self.content);
	self.toolImage:setDepth(11);
	self.toolImage:setLocation(-105, 0);
	self.toolImage:setCanClick(true);

	self.mask = UICreate.createUIAtlasImage(self.toolImage.content, "common_atlas_1", "ui_common_black_50", 0, 0, 77, 77);
	self.mask.name = "mask";
	self.mask:setDepth(15);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 157, 39, 0, 0);
	self.redDot:setDepth(10);
	self.redDot:setEnable(false);

	self.selectIcon:setEnable(false);
end

function Lua_GodWingTransItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.select then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p2");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p1");
	end
	self.selectIcon:setEnable(data.select);

	self.itemVo = Lua_ToolVo.new(data.illusion_id); 
	self.toolImage.data = self.itemVo;
	self.toolImage:showRoundEff(true);

	self.name.text = data.name;
	if data.isUnlock then
		self.tipsObj:SetActive(true);

		self.tipsIcon:setAltas("common_atlas_2", "ui_common_tishi2");
		self.tipsTxt.text = LanUtil.getValue(110259); -- 可啟動
	elseif data.isIllusion then
		self.tipsObj:SetActive(true);

		self.tipsIcon:setAltas("common_atlas_2", "ui_common_tishi");
		self.tipsTxt.text = LanUtil.getValue(110258); -- 已化形
	else
		self.tipsObj:SetActive(false);
	end

	self.mask:setEnable(data.is_unlock ~= 1);
	self.redDot:setEnable(data.isRedDot);
end

function Lua_GodWingTransItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.toolImage.item_bg.width;
	local height = self.toolImage.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2 - 105, self.itemY - height / 2, width, height);
	self.toolImage:showRoundEff(showRect:containeRect(rect) and self.itemVo.color >= 3);
end

function Lua_GodWingTransItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("TRANS_PANEL_BTN", self._data);
end

function Lua_GodWingTransItem:dispose()
	if self.toolImage ~= nil then
		self.toolImage:dispose();
		self.toolImage = nil;
	end
	if self.mask ~= nil then
		self.mask:dispose();
		self.mask = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end