checkRequire("Lua_ServantTransPanel"); -- 侍寵幻化
checkRequire("Lua_ServantWeaponTransPanel"); -- 寵武幻化
checkRequire("Lua_ServantWingTransPanel"); -- 寵翼幻化
checkRequire("Lua_ServantMountTransPanel"); -- 寵騎幻化
checkRequire("Lua_MountTransPanel"); -- 坐騎幻化
checkRequire("Lua_FootprintTransPanel"); -- 足跡幻化
checkRequire("Lua_MagicWeaponTransPanel"); -- 法寶幻化
checkRequire("Lua_TalismanTransPanel"); -- 仙器幻化
checkRequire("Lua_GodWingTransPanel"); -- 神翼幻化
Lua_TransWindow = class("Lua_TransWindow", Lua_SecondSizeWindow);
function Lua_TransWindow:ctor()
	Lua_MsgUtil.callFunc("FOOTPRINT_PANEL_MODEL_SHOW", false);
	self:superCall("ctor");

	self.windowName = "Lua_TransWindow";
end

function Lua_TransWindow:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.funcOpenData:isOpened(10087) == false then
		local tipsStr = getConfig({"func_open", 10087, "advance_message"});
		if tipsStr ~= nil then
			OperateAlert.show(tipsStr);
		end
	end

	self.btnListBg = UICreate.createUIAtlasImage(self.content, "role_atlas", "ui_figure_bg_06", -466, -31, 203, 570);
	self.btnListBg.name = "btnListBg";
	self.btnListBg:setDepth(1);

	self.tabList = Array();
	self.tabList:add({panelIndex = 1, name = LanUtil.getValue(110250), panel = Lua_ServantTransPanel, openId = 10008, eventIds = {11113, 11114}});
	self.tabList:add({panelIndex = 2, name = LanUtil.getValue(110251), panel = Lua_ServantWeaponTransPanel, openId = 10018, eventIds = {11119, 11120}});
	self.tabList:add({panelIndex = 3, name = LanUtil.getValue(110253), panel = Lua_ServantWingTransPanel, openId = 10061, eventIds = {11131, 11132}});
	self.tabList:add({panelIndex = 4, name = LanUtil.getValue(110252), panel = Lua_ServantMountTransPanel, openId = 10065, eventIds = {11125, 11126}});
	self.tabList:add({panelIndex = 5, name = LanUtil.getValue(110254), panel = Lua_MountTransPanel, openId = 10010, eventIds = {11161, 11162}});
	self.tabList:add({panelIndex = 6, name = LanUtil.getValue(110255), panel = Lua_FootprintTransPanel, openId = 10025, eventIds = {11166, 11167}});
	self.tabList:add({panelIndex = 7, name = LanUtil.getValue(110256), panel = Lua_MagicWeaponTransPanel, openId = 10050, eventIds = { 11151, 11152}});
	self.tabList:add({panelIndex = 8, name = LanUtil.getValue(110257), panel = Lua_TalismanTransPanel, openId = 10068, eventIds = {11156, 11157}});
	self.tabList:add({panelIndex = 9, name = LanUtil.getValue(110263), panel = Lua_GodWingTransPanel, openId = 10066, eventIds = {11195, 11196}});
	
	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 164, 552));
	self.dragList:setLocation(-466, -31, 0);
	self.dragList:setListCell(Lua_TransItem, 69, 164, 1);
	self.dragList:setLuaArrayData(self.tabList, false);

	local windowData = Lua_WindowUtil.getWinData(self.windowName, true);
	local toindex;
	self.showToolVo = nil;
	if windowData ~= nil then
		if type(windowData) == "table" then
			if windowData.openIdx ~= nil and windowData.openIdx >= 1 and windowData.openIdx <= 9 then
				toindex = self.tabList[windowData.openIdx].panelIndex;
				if windowData.data ~= nil then
					local isFunOpened = DataCenter.funcOpenData:isOpened(self.tabList[windowData.openIdx].openId);
					if isFunOpened == true then
						self.showToolVo = windowData.data;
					end
				end
			end
		elseif type(windowData) == "number" then
			if windowData >= 1 and windowData <= 9 then
				toindex = self.tabList[windowData].panelIndex;
			end
		end
	end

	if toindex == nil then
		toindex = 1;
	end
	self:onBtnClick(toindex)
	self:addLuaEvent("SETSELECTED_BTN", self, self.onBtnClick);
end

function Lua_TransWindow:onBtnClick(index)
	self:setSelected(index);
	self.dragList:moveToIndex(index, true);
	self.dragList:setSelected(index);
end

function Lua_TransWindow:setSelected(val)
	if self.panelIndex == val then
		return;
	end

	local obj = self.tabList[val];
	if DataCenter.funcOpenData:isOpened(obj.openId) == false then
		local tipsStr = getConfig({"func_open", obj.openId, "advance_message"});
		if tipsStr ~= nil then
			OperateAlert.show(tipsStr);
		end
		return;
	end
	self:setTitleTxt(obj.name);

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.panelIndex = val;

	local objClass = obj.panel;
	if objClass == nil then
		return;
	end

	self.curPanel = objClass.new(self.content);
	if self.showToolVo ~= nil then
		if self.curPanel.showDefaultData ~= nil then
			self.curPanel:showDefaultData(self.showToolVo);
		end
		self.showToolVo = nil;
	end
	self.curIndex = val;
end

function Lua_TransWindow:dispose()
	if self.btnListBg ~= nil then
		self.btnListBg:dispose();
		self.btnListBg = nil;
	end
	if self.tabList ~= nil then
		self.tabList:dispose();
		self.tabList:clear();
		self.tabList = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	Lua_MsgUtil.callFunc("FOOTPRINT_PANEL_MODEL_SHOW", true);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TransItem = class("Lua_TransItem", Lua_ListCell);
function Lua_TransItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TransItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "roleWindow", "fashion_nor", 0, 0, 0, 0);
	self.bg:setDepth(0);

	self.name = UICreate.createLabel(self.content, "", 0, 0, 250, 30, 26);
	self.name.pivot = UIWidget.Pivot.Center;
	self.name.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.name:setDepth(1)

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 74, 22, 0, 0);
	self.redDot:setDepth(2);
	self.redDot:setEnable(false);

	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
end

function Lua_TransItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.name.text = data.name;
	self:updateRedDot()

	self.bg:setGray(not DataCenter.funcOpenData:isOpened(data.openId));
end

function Lua_TransItem:updateRedDot()
	self.redDot:setEnable(false);
	for i,v in ipairs(self._data.eventIds) do
		if DataCenter.redDotData:getRedDotStateByEventId(v) then
			self.redDot:setEnable(true);
		end
	end
end

function Lua_TransItem:onPlayerSoundClick()
	Lua_MsgUtil.callFunc("SETSELECTED_BTN", self._data.panelIndex);
end

function Lua_TransItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.bg:setAltas("common_atlas_1", "ui_common_btn_p5");
		self.name.colorStr = Lua_ColorDefine.transColor("FFFFFF");   
	else
		self.bg:setAltas("common_atlas_1", "ui_common_btn_p6"); 
		self.name.colorStr = Lua_ColorDefine.transColor("D5DADE");   
	end
end

function Lua_TransItem:dispose()
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	if self.name ~= nil then
		self.name:dispose();
		self.name = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end