Lua_TransBaseItem = class("Lua_TransBaseItem", Lua_ListCell);
function Lua_TransBaseItem:ctor(p)
    self:superCall("ctor", p, "ServantTransItem_skin");
end

function Lua_TransBaseItem:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImage = Lua_ToolImage.new(self.content);
	self.toolImage:setDepth(11);
	self.toolImage:setLocation(-105, 0);
	self.toolImage:setCanClick(true);

	self.mask = UICreate.createUIAtlasImage(self.toolImage.content, "common_atlas_1", "ui_common_black_50", 0, 0, 77, 77);
	self.mask.name = "mask";
	self.mask:setDepth(15);
end

function Lua_TransBaseItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemVo = Lua_ToolVo.new(data.itemId);
	self.toolImage.data = self.itemVo;
	self.toolImage:showRoundEff(true);

	if data.isSelected == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p2");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p1");
	end
	self.selectIcon:setEnable(data.isSelected);
	self.mask:setEnable(data.isUnlock == 0);
end

function Lua_TransBaseItem:setRedDotState(isShow, pos, depth)
	if self.redDot == nil then
		pos = pos == nil and Vector3(0, 0, 0) or pos;
		self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", pos.x, pos.y, 0, 0);
		depth = depth == nil and 20 or depth;
		self.redDot:setDepth(depth);
	end
	self.redDot:setEnable(isShow);
end

function Lua_TransBaseItem:checkOutBound(showRect)
	if self.data == nil then
		return;
	end
	
	local width = self.toolImage.item_bg.width;
	local height = self.toolImage.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2 - 105, self.itemY - height / 2, width, height);
	self.toolImage:showRoundEff(showRect:containeRect(rect) and self.itemVo.color >= 3);
end

function Lua_TransBaseItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("TRANS_PANEL_BTN", self.data);
end

function Lua_TransBaseItem:dispose()
	if self.toolImage ~= nil then
		self.toolImage:dispose();
		self.toolImage = nil;
	end
	if self.mask ~= nil then
		self.mask:dispose();
		self.mask = nil;
	end
	self.data = nil;
	
	self:superCall("dispose");
end