checkRequire("Lua_ServantTransItem");
Lua_TransBasePanel = class("Lua_TransBasePanel", Lua_DisplayObject);
function Lua_TransBasePanel:ctor(p)
    self._dataList = nil;
    self.selectedIndex = 1;
    self.isfunBtn1Enable = nil;
    self.isfunBtn2Enable = nil;
    self._data = nil;
    self:superCall("ctor", p, "TransPanel_skin");
end

function Lua_TransBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self:initPanel();

	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
	self:addLuaEvent("TRANS_PANEL_BTN", self, self.onItemBtn);
	-- 图标红点更新
	-- self:addLuaEvent("AUTO_TRANS", self, self.autoTrans);
end

-- 默认显示选中 vo为道具vo
function Lua_TransBasePanel:showDefaultData(vo)
	self.defaultData = vo;
end

function Lua_TransBasePanel:initPanel()
	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 356, 540));
	self.dragList:setLocation(370, -24, 0);
	self.dragList:setListCell(Lua_ServantTransItem, 113, 356, 1);

	self.attrDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 510, 70));
	self.attrDragList:setListCell(Lua_PetTransAttrItem, 30, 240, 2);
	self.attrDragList:setLocation(-88, -155, 0);
	self.attrDragList.canDrag = false;
	
	self:initModelInfo();

	self:setFunBtn(self.funBtn1, "", false);
	self:setFunBtn(self.funBtn2, "", false);

	self.funBtn1:addClickFuntion(self, self.onFunBtn1);
	self.funBtn2:addClickFuntion(self, self.onFunBtn2);
	self.resPlusBtn:addClickFuntion(self, self.onResPlusBtn);
end

function Lua_TransBasePanel:initModelInfo()
	if self.modelType == 1 then
		local imgPos = Vector2(-30, 80);
		local imgSize = Vector2(1016, 373);
		local modelRot = Vector3(0, 180, 0);
		local modelOffset = Vector2(-105, -300);

		self.modelTexture = UIModelTexture();
		self.modelTexture:init(self.content, imgPos, imgSize, 2, modelRot, modelOffset, 360);
		self.modelTexture:setCamPos(0, -5000, 0);
		self.modelTexture:setCamView(8);
		self.modelTexture:setRotEnable(true, 0, 0, 900, 400, 2);
	elseif self.modelType == 2 then
		self.modelTexture = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
		self.modelTexture:SetRenderQueue(self.showInfoBg, 1, 2);
		self.modelTexture.circulate = true;
		self.modelTexture:setLocation(-80, -50, 0);
		self.modelTexture:setSacle(200, 200, 200);
		self.modelTexture:setRot(0, 0, 0);
	end

	if self.modelType == 1 then
		self.rootPos = self.modelTexture.root.transform.localPosition;
		self.rootRot = self.modelTexture.root.transform.localEulerAngles;
		self.rootSca = self.modelTexture.root.transform.localScale;
		self.effectPos = self.modelTexture.uiEffect.mainContent.transform.localPosition;
		self.effectRot = self.modelTexture.uiEffect.mainContent.transform.localEulerAngles;
		self.effectSca = self.modelTexture.uiEffect.mainContent.transform.localScale;
	elseif self.modelType == 2 then
		self.effectPos = self.modelTexture.mainContent.transform.localPosition;
		self.effectRot = self.modelTexture.mainContent.transform.localEulerAngles;
		self.effectSca = self.modelTexture.mainContent.transform.localScale;
	end
end

function Lua_TransBasePanel:setFunBtn(btn, text, isEnable, isShow)
	btn.label = text;
	if isEnable == nil then
		isEnable = true;
	end

	local normalStr = Lua_ColorDefine.transColor("FFFFFF");
	local grayStr = Lua_ColorDefine.transColor("B6B6B6");
	if btn == self.funBtn1 and self.isfunBtn1Enable ~= isEnable then
		self.isfunBtn1Enable = isEnable;
		btn:setMouseEnable(isEnable);
		btn:setStyle(isEnable and 13 or 12);
		btn.txt.colorStr = isEnable and normalStr or grayStr;
	elseif btn == self.funBtn2 and self.isfunBtn2Enable ~= isEnable then
		self.isfunBtn2Enable = isEnable;
		btn:setMouseEnable(isEnable);
		btn:setStyle(isEnable and 15 or 14);
		btn.txt.colorStr = isEnable and normalStr or grayStr;
	end

	if isShow == nil then
		isShow = true;
	end
	btn:setEnable(isShow);
end

function Lua_TransBasePanel.Get:data()
	return self._data;
end

function Lua_TransBasePanel.Set:data(val)
	self._data = val;
	self.dataList = val.servantTransList;
	self:updateRedDot();
end

function Lua_TransBasePanel.Get:dataList()
	return self._dataList;
end

function Lua_TransBasePanel.Set:dataList(val)
	self._dataList = val;

	if self.defaultData ~= nil then
		for i = 1, self._dataList.getSize() do
			if self._dataList[i].fragmentItemId == self.defaultData.id or self._dataList[i].itemId == self.defaultData.id then
				self.selectedIndex = i;
				break;
			end
		end
		self.defaultData = nil;
	end

	-- 因为Data类会重新排序，需要根据道具id来重新获得 self.selectedIndex
	if self.curItemId ~= nil then
		for i = 1, self._dataList:getSize() do
			if self._dataList[i].itemId == self.curItemId then
				self.selectedIndex = i;
				break;
			end
		end
	end
	self:updateUnrealInfo(true);
end

function Lua_TransBasePanel:updateRedDot(obj)
	if self.eventIdList ~= nil then
		self:setFunBtn1RedDotState(obj);
		-- self:setFunBtn2RedDotState(obj);
	end
end

function Lua_TransBasePanel:setFunBtn1RedDotState(obj)
	if self.dataList == nil or self.selectedIndex == nil or self.dataList[self.selectedIndex] == nil then
		return;
	end

	local selectedData = self.dataList[self.selectedIndex];
	local idList = self.eventIdList.funBtn1;
	local isShowRedDot = self:isShowRedDot(idList, obj);
	local qohNum = selectedData.ownedFullItemNum * selectedData.neededFragmentItemNum + selectedData.ownedFragmentItemNum;
	local needNum = selectedData.lvlUpitemNum;
	if selectedData.isUnlock == 0 and selectedData.isActivable or selectedData.isUnlock == 1 and qohNum >= needNum then
		self.funBtn1RedDot = self:setRedDotState(self.funBtn1.mainContent, self.funBtn1RedDot, isShowRedDot, Vector3(84, 21, 0));
	else
		self.funBtn1RedDot = self:setRedDotState(self.funBtn1.mainContent, self.funBtn1RedDot, false, Vector3(84, 21, 0));
	end
end

function Lua_TransBasePanel:setFunBtn2RedDotState(obj)
	local idList = self.eventIdList.funBtn2;
	local isShowRedDot = self:isShowRedDot(idList, obj);
	self.funBtn2RedDot = self:setRedDotState(self.funBtn1.mainContent, self.funBtn2RedDot, isShowRedDot, Vector3(84, 21, 0))
end

function Lua_TransBasePanel:isShowRedDot(idList, obj)
	local isShowRedDot = false;
	for k, v in ipairs(idList) do
		if obj == nil then
			if DataCenter.redDotData:getRedDotStateByEventId(v) then
				isShowRedDot = true;
			end
		else
			if v == obj.evenId then
				if obj.bShow == true then
					isShowRedDot = true;
				end
			else
				if DataCenter.redDotData:getRedDotStateByEventId(v) then
					isShowRedDot = true;
				end
			end
		end
	end
	return isShowRedDot;
end

function Lua_TransBasePanel:setRedDotState(parentObj, redDot, isShow, pos, depth)
	if redDot == nil then
		pos = pos == nil and Vector3(0, 0, 0) or pos;
		redDot = UICreate.createUIAtlasImage(parentObj, "common_atlas_1", "ui_common_hongdian", pos.x, pos.y, 0, 0);
		depth = depth == nil and 20 or depth;
		redDot:setDepth(depth);
	end

	redDot:setEnable(isShow);
	return redDot;
end

function Lua_TransBasePanel:onItemBtn(data)
	for i = 1, self._dataList.getSize() do
		if self._dataList[i] == data then
			self.selectedIndex = i;
			break;
		end
	end

	self:updateUnrealInfo();
	self:updateRedDot();
end

-- 幻化信息
function Lua_TransBasePanel:updateUnrealInfo(state)
	local index;
	for i = 1, self._dataList:getSize() do
		self._dataList[i].isSelected = self.selectedIndex == i;
		if self.selectedIndex == i then
			self.curItemId = self._dataList[i].itemId;
			index = i;
		end
	end
	self.dragList:setLuaArrayData(self.dataList, false);
	if state then
		self.dragList:moveToIndex(index, true);
	end

	self:setModelInfo();
	self:showCurrent();
end

function Lua_TransBasePanel:setModelInfo()
	local curModel = self.dataList[self.selectedIndex].modelId;
	local modelInfo = self.petData:getModelInfo(curModel);
	local rootPos = Vector3(-105, -133, 5000);
	local rootRot = Vector3(0, 0, 0);
	local rootSca = Vector3(1, 1, 1);
	local effectPos = Vector3(0, 0, 0);
	local effectRot = Vector3(0, 180, 0);
	local effectSca = Vector3(360, 360, 360);
	if self.modelType == 1 then
		self:startTimer();
		self:onLoadingModel();
		
		self.modelTexture:setEffectActive(false);
		self.modelTexture:addLuaLoadedCallBack(self, self.delayShowModel);
	end
	
	if modelInfo == nil then
		self.modelTexture:setUrl("/mounts/" .. curModel, tostring(curModel));
	else
		-- print("modelInfo not nil", modelInfo.fileName, modelInfo.modelName);
		self.modelTexture:setUrl(modelInfo.floder .. "/" .. modelInfo.fileName, tostring(modelInfo.modelName));

		if modelInfo.rootPos == nil then
			rootPos = self.rootPos;
		else
			rootPos = Vector3(modelInfo.rootPos[1], modelInfo.rootPos[2], modelInfo.rootPos[3]);
		end

		if modelInfo.rootRot == nil then
			rootRot = self.rootRot;
		else
			rootRot = Vector3(modelInfo.rootRot[1], modelInfo.rootRot[2], modelInfo.rootRot[3]);
		end

		if modelInfo.rootSca == nil then
			rootSca = self.rootSca;
		else
			rootSca = Vector3(modelInfo.rootSca[1], modelInfo.rootSca[2], modelInfo.rootSca[3]);
		end

		if modelInfo.pos == nil then
			effectPos = self.effectPos;
		else
			effectPos = Vector3(modelInfo.pos[1], modelInfo.pos[2], modelInfo.pos[3]);
		end

		if modelInfo.rot == nil then
			effectRot = self.effectRot;
		else
			effectRot = Vector3(modelInfo.rot[1], modelInfo.rot[2], modelInfo.rot[3]);
		end

		if modelInfo.sca == nil then
			effectSca = self.effectSca;
		else
			effectSca = Vector3(modelInfo.sca[1], modelInfo.sca[2], modelInfo.sca[3]);
		end
	end
	-- self.modelTexture.root.transform.localEulerAngles = Vector3(0, 0, 0);
    LuaUtil.setObjRot(self.modelTexture.root, 0, 0, 0);

	if self.modelType == 1 then
		self.modelTexture:setEffectPos(effectPos.x, effectPos.y, effectPos.z);
		self.modelTexture:setModelAngle(effectRot.x, effectRot.y, effectRot.z);
		self.modelTexture.uiEffect:setSacle(effectSca.x, effectSca.y, effectSca.z);
		-- self.modelTexture.root.transform.localPosition = Vector3(rootPos.x, rootPos.y, rootPos.z);
		-- self.modelTexture.root.transform.localEulerAngles = rootRot;
		-- self.modelTexture.root.transform.localScale = rootSca;
	    LuaUtil.setObjRot(self.modelTexture.root, rootRot.x, rootRot.y, rootRot.z);
		LuaUtil.setObjPos(self.modelTexture.root, rootPos.x, rootPos.y, rootPos.z);
		LuaUtil.setObjScale(self.modelTexture.root, rootSca.x, rootSca.y, rootSca.z);
	end
end

function Lua_TransBasePanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_TransBasePanel", 0.1, self, self.onLoadingModel);
	end
end

function Lua_TransBasePanel:onLoadingModel()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_loadingring", "gui_loadingring", -88, 63);
		self.effect:SetRenderQueue(self.showInfoBg, 5, 2, false);
	end
end

function Lua_TransBasePanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onLoadingModel);
	end
end

function Lua_TransBasePanel:delayShowModel()
	if self.effect ~= nil then
		self.effect:setEnable(false);
		self.effect:dispose();
		self.effect = nil;
	end
	self:endTimer();
	self.modelTexture:setEffectActive(true);
end

function Lua_TransBasePanel:showCurrent()
	self:setResText();
	self:updateFunBtn();
	self:updateAttrText();

	local tv = Lua_ToolVo.new(self.dataList[self.selectedIndex].itemId);
	self.outputTxt.text = tv.interfaceOutput;
end

function Lua_TransBasePanel:setResText()
	local selectedData = self.dataList[self.selectedIndex];
	local qoh = selectedData.ownedFullItemNum * selectedData.neededFragmentItemNum + selectedData.ownedFragmentItemNum;
	local needNum = selectedData.neededFragmentItemNum;
	local lvlUpNum = selectedData.lvlUpitemNum;
	if selectedData.isUnlock == 1 then
		if qoh >= lvlUpNum then
			self.needNumTxt.text = qoh .. "/" .. lvlUpNum;
		else
			self.needNumTxt.text = "[FF1616]" .. qoh .. "/" .. lvlUpNum;
		end
	else
		if qoh >= needNum then
			self.needNumTxt.text = qoh .. "/" .. needNum;
		else
			self.needNumTxt.text = "[FF1616]" .. qoh .. "/" .. needNum;
		end
	end
end

function Lua_TransBasePanel:updateFunBtn()
	self.funBtn2.txt.spacingX = 12
	if self.dataList[self.selectedIndex].isUnlock == 1 then
		-- print("激活");
		self:setFunBtn(self.funBtn1, LanUtil.getValue(110511));
		if self.dataList[self.selectedIndex].isTransmogrified == false then
			self:setFunBtn(self.funBtn2, LanUtil.getValue(110260));
		else
			self.funBtn2.txt.spacingX = 0
			self:setFunBtn(self.funBtn2, LanUtil.getValue(110262));
		end
		self.funBtn1:setBtnEnable(true);
	else
		-- print("未激活");
		self:setFunBtn(self.funBtn2, LanUtil.getValue(110260), false);
		if self.dataList[self.selectedIndex].isActivable == true then
			self:setFunBtn(self.funBtn1, LanUtil.getValue(110512));
		elseif self.dataList[self.selectedIndex].isActivable == false then
			self:setFunBtn(self.funBtn1, LanUtil.getValue(110512), false);
		end
	end
end

function Lua_TransBasePanel:updateAttrText()
	local selectedData = self.dataList[self.selectedIndex];
	local attrArr = self.data:getAttrData(selectedData.illId, selectedData.illLvl, selectedData.isUnlock);
	self.attrDragList:setLuaArrayData(attrArr, false);
	if attrArr:getSize() > 4 then
		self.attrDragList:setRect(Vector4(0, 0, 510, 100));
		self.attrDragList:setSubPos(-120, 10, 0); -- 30 -> (y + 90 /2 - 30 / 2)
	else
		self.attrDragList:setRect(Vector4(0, 0, 510, 70));
		self.attrDragList:setSubPos(-120, 0, 0); -- -255 -> (x - 510 /2 + 240 / 2)
	end
end

function Lua_TransBasePanel:autoTrans()
	if self._data.isSuccess == 1 then
		self._data:sTransmogrify(self._dataList[self.selectedIndex].illId);
	end
	self._data.isSuccess = 0;
end

function Lua_TransBasePanel:onFunBtn1(go)
	local selectedData = self.dataList[self.selectedIndex];
	if selectedData.isUnlock == 1 then
		self.data:sLvlUp(selectedData.illId);
	elseif selectedData.isUnlock == 0 then
		self.data:sActivate(selectedData.illId);
		-- DataCenter.servantTransData:sLvlUp(selectedData.illId);
	end
end

function Lua_TransBasePanel:onFunBtn2(go)
	local selectedData = self.dataList[self.selectedIndex];
	if selectedData.isTransmogrified then
		self._data:sRestore();
	else
		self._data:sTransmogrify(self.dataList[self.selectedIndex].illId);
	end
end

function Lua_TransBasePanel:onResPlusBtn(go)
	local condItemDic = self._dataList[self.selectedIndex].condItemDic;
	local arr = Array();
	arr:add(Lua_ToolVo.new(condItemDic.fragmentItem.id, 1, 1));
	arr:add(Lua_ToolVo.new(condItemDic.fullItem.id, 1, 1));
	Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
end

function Lua_TransBasePanel:setAttackTxt(num, increase, dis)
	if dis == nil then
		dis = 10;
	end
	self.attackTxt.text = num;

	-- self.increaseAttackObj.transform.localPosition = Vector3(self.attackTxt.transform.localPosition.x + self.attackTxt.width + dis, 1, 0);
	LuaUtil.setObjPos(self.increaseAttackObj, self.attackTxt.transform.localPosition.x + self.attackTxt.width + dis, 1, 0);
	if increase == nil then
		self.increaseAttackObj:SetActive(false);
	else
		self.increaseAttackObj:SetActive(true);
		self.increaseAttackTxt.text = increase;
	end
end

function Lua_TransBasePanel:setHpTxt(num, increase, dis)
	if dis == nil then
		dis = 10;
	end
	self.hpTxt.text = num;

	-- self.increaseHpObj.transform.localPosition = Vector3(self.hpTxt.transform.localPosition.x + self.hpTxt.width + dis, 1, 0);
	LuaUtil.setObjPos(self.increaseHpObj, self.hpTxt.transform.localPosition.x + self.hpTxt.width + dis, 1, 0);
	if increase == nil then
		self.increaseHpObj:SetActive(false);
	else
		self.increaseHpObj:SetActive(true);
		self.increaseHpTxt.text = increase;
	end
end

function Lua_TransBasePanel:setDefenceTxt(num, increase, dis)
	if dis == nil then
		dis = 10;
	end
	self.defenceTxt.text = num;

	self.increaseDefenceTxt.text = increase;
	-- self.increaseDefenceObj.transform.localPosition = Vector3(self.defenceTxt.transform.localPosition.x + self.defenceTxt.width + dis, 1, 0);
	LuaUtil.setObjPos(self.increaseDefenceObj, self.defenceTxt.transform.localPosition.x + self.defenceTxt.width + dis, 1, 0);
	if increase == nil then
		self.increaseDefenceObj:SetActive(false);
	else
		self.increaseDefenceObj:SetActive(true);
		self.increaseDefenceTxt.text = increase;
	end
end

function Lua_TransBasePanel:setCritTxt(num, increase, dis)
	if dis == nil then
		dis = 10;
	end
	self.critTxt.text = num;

	-- self.increaseCritObj.transform.localPosition = Vector3(self.critTxt.transform.localPosition.x + self.critTxt.width + dis, 1, 0);
	LuaUtil.setObjPos(self.increaseCritObj, self.critTxt.transform.localPosition.x + self.critTxt.width + dis, 1, 0);
	if increase == nil then
		self.increaseCritObj:SetActive(false);
	else
		self.increaseCritObj:SetActive(true);
		self.increaseCritTxt.text = increase;
	end
end

function Lua_TransBasePanel:dispose()
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	self:endTimer();
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_PetTransAttrItem = class("Lua_PetTransAttrItem", Lua_ListCell);
function Lua_PetTransAttrItem:ctor(p)
	self:superCall("ctor", p, "petAttItem_skin");
end

function Lua_PetTransAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_PetTransAttrItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.label.text = data.attrStr .. "：";
	self.txt.text = data.curValue;

	if data.nextValue > 0 then
		if data.show_percent == 1 then
			self.increaseTxt.text = data.nextValue .. "%";
		else
			self.increaseTxt.text = data.nextValue
		end
	end

	local posX = self.label.mainContent.transform.localPosition.x;
	local posY = self.label.mainContent.transform.localPosition.y;
	self.txt:setLocation(posX + self.label.width, posY);

	posX = self.txt.mainContent.transform.localPosition.x;
	posY = self.txt.mainContent.transform.localPosition.y;
	-- self.increaseObj.transform.localPosition = Vector3(posX + self.txt.width, posY, 0);
	LuaUtil.setObjPos(self.increaseObj, posX + self.txt.width, posY, 0);
	self.increaseObj:SetActive(data.nextValue > 0);
end