-- 足跡幻化
checkRequire("Lua_TransBasePanel");
Lua_FootprintTransPanel = class("Lua_FootprintTransPanel", Lua_TransBasePanel);
function Lua_FootprintTransPanel:ctor(p)
	self.modelType = 2;
	self:superCall("ctor", p);
end

function Lua_FootprintTransPanel.Get:eventIdList()
	if self._eventIdList == nil then
		self._eventIdList = {funBtn1 = {11166, 11167}};
	end
	return self._eventIdList;
end

function Lua_FootprintTransPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("FOOTPRINT_TRANS_PANEL_UPDATE", self, self.updatePanel);
	DataCenter.footprintTransData:sGetPanelInfo();
end

function Lua_FootprintTransPanel:updatePanel()
	self.petData = DataCenter.footprintData;
	self.data = DataCenter.footprintTransData;
end

function Lua_FootprintTransPanel:setModelInfo()
	Lua_CommonUtil.removeTimer(self, self.transEffectLoop);
	Lua_CommonUtil.addTimer("Lua_FootprintTransPanel", 2, self, self.transEffectLoop);

	local curModel = self.dataList[self.selectedIndex].modelId;
	local effectInfo = self.petData:getEffectInfo(curModel);
	if effectInfo == nil then
		self.modelTexture:setUrl("/mounts/"..curModel, tostring(curModel));
	else
		self.modelTexture:setUrl(effectInfo.floder.."/"..effectInfo.path, tostring(effectInfo.path));
	end

	local modelInfo = self.petData:getModelInfo(curModel);
	if modelInfo == nil then
		effectPos = self.effectPos;
		effectRot = self.effectRot;
		effectSca = self.effectSca;
	else
		if modelInfo.pos == nil then
			effectPos = self.effectPos;
		else
			effectPos = Vector3(modelInfo.pos[1], modelInfo.pos[2], modelInfo.pos[3]);
		end

		if modelInfo.rot == nil then
			effectRot = self.effectRot;
		else
			effectRot = Vector3(modelInfo.rot[1], modelInfo.rot[2], modelInfo.rot[3]);
		end

		if modelInfo.sca == nil then
			effectSca = self.effectSca;
		else
			effectSca = Vector3(modelInfo.sca[1], modelInfo.sca[2], modelInfo.sca[3]);
		end
	end
	self.modelTexture:setLocation(effectPos.x, effectPos.y, effectPos.z);
	self.modelTexture:setRot(effectRot.x, effectRot.y, effectRot.z);
	self.modelTexture:setSacle(effectSca.x, effectSca.y, effectSca.z);
end

function Lua_FootprintTransPanel:transEffectLoop()
	if self.modelTexture == nil then
		return;
	end
	
	local effectRoot = self.modelTexture.mainContent;
	if effectRoot ~= nil then
		effectRoot:SetActive(false);
		effectRoot:SetActive(true);
	end
end

function Lua_FootprintTransPanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.transEffectLoop);

	self:superCall("dispose");
end